%global momorel 1

Summary: Universal Addresses to RPC Program Number Napper
Name: rpcbind
Version: 1.2.5
Release: %{momorel}m%{?dist}
Group: System Environment/Daemons
License: BSD
URL: http://nfsv4.bullopensource.org

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source0: http://downloads.sourceforge.net/rpcbind/%{name}-%{version}.tar.bz2
NoSource: 0
Source1: rpcbind.service
Source2: rpcbind.socket
Source3: rpcbind.sysconfig

Requires: glibc-common setup
Conflicts: man-pages < 2.43-12
BuildRequires: automake, autoconf, libtool, systemd, systemd-devel
BuildRequires: libtirpc-devel >= 1.0.3, quota-devel, tcp_wrappers-devel
Requires(pre): coreutils shadow-utils >= 4.1.4
Requires(post): chkconfig systemd
Requires(preun): systemd
Requires(postun): systemd coreutils

Provides: portmap = %{version}-%{release}
Obsoletes: portmap <= 4.0-65.3

%description
The rpcbind utility is a server that converts RPC program numbers into
universal addresses.  It must be running on the host to be able to make
RPC calls on a server on that machine.

%prep
%setup -q

%build
%ifarch s390 s390x
PIE="-fPIE"
%else
PIE="-fpie"
%endif
export PIE

RPCBUSR=rpc
RPCBDIR=/tmp
CFLAGS="`echo $RPM_OPT_FLAGS $ARCH_OPT_FLAGS $PIE`"

autoreconf -fisv
%configure CFLAGS="$CFLAGS" LDFLAGS="-pie" \
    --enable-warmstarts \
    --with-statedir="$RPCBDIR" \
    --with-rpcuser="$RPCBUSR" \
    --enable-libwrap \
    --enable-debug

%make

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

mkdir -p %{buildroot}{/sbin,/usr/sbin}
mkdir -p %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_mandir}/man8 
mkdir -p %{buildroot}/var/lib/rpcbind
mkdir -p %{buildroot}/etc/sysconfig/
make DESTDIR=%{buildroot} install

mv -f ${RPM_BUILD_ROOT}%{_bindir}/rpcinfo %{buildroot}/%{_sbindir}
install -m644 %{SOURCE1} %{buildroot}%{_unitdir}
install -m644 %{SOURCE2} %{buildroot}%{_unitdir}
install -m644 %{SOURCE3} %{buildroot}/etc/sysconfig/rpcbind

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%pre
# Check the validity of the rpc uid and gid.
# If they don't exist, create them
# If they exist but are the wrong value, remove them 
#   and recreate them with the correct value
# If they exist and are the correct value do nothing
rpcid=`getent passwd rpc | cut -d: -f 3`
if [ -n "$rpcid" -a "$rpcid" != "32" ]; then
       /usr/sbin/userdel  rpc 2> /dev/null || :
       /usr/sbin/groupdel rpc 2> /dev/null || : 
fi
if [ -z "$rpcid" -o "$rpcid" != "32" ]; then
/usr/sbin/groupadd -o -g 32 rpc > /dev/null 2>&1
/usr/sbin/useradd -o -l -c "Rpcbind Daemon" -d /var/lib/rpcbind -g 32 \
    -M -s /sbin/nologin -u 32 rpc > /dev/null 2>&1
fi

# remove /var/lib/rpcbind directory from previous versions
if [ -d "/var/lib/%{name}" ]; then
rm -rf /var/lib/%{name}
fi

%post
/bin/systemctl enable rpcbind.socket >/dev/null 2>&1 || :

%preun
%systemd_preun rpcbind.service rpcbind.socket
if [ $1 -eq 0 ]; then
	/usr/sbin/userdel  rpc 2>/dev/null || :
	/usr/sbin/groupdel rpc 2>/dev/null || :
fi

%postun
%systemd_postun_with_restart rpcbind.service rpcbind.socket

%triggerun -- rpcbind < 0.2.0-6m
%{_bindir}/systemd-sysv-convert --save rpcbind >/dev/null 2>&1 ||:
/bin/systemctl --no-reload enable rpcbind.service >/dev/null 2>&1
/sbin/chkconfig --del rpcbind >/dev/null 2>&1 || :
/bin/systemctl try-restart rpcbind.service >/dev/null 2>&1 || :

%triggerun -- rpcbind > 0.2.2-2.0
/bin/systemctl enable rpcbind.socket

%files
%doc AUTHORS ChangeLog README
%config(noreplace) /etc/sysconfig/rpcbind
%{_sbindir}/rpcbind
%{_sbindir}/rpcinfo
%{_mandir}/man8/*
%{_unitdir}/rpcbind.service
%{_unitdir}/rpcbind.socket

%changelog
* Mon Oct  8 2018 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.2.5-1m)
- version 1.2.5
- build against libtirpc-1.0.3

* Sun Oct  4 2015 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.2.3-1m)
- update to 0.2.3
- [SECURITY] CVE-2015-7236
- Change RPCBDIR to be /tmp since that will exist after a 
  reboot and bindings wil be perserved during upgrades
  but not reboots.

* Tue Aug 26 2014 Yohsuke Ooi <meke@momonga-linux.org>
- (0.2.1-1m)
- update 0.2.1

* Wed Nov 20 2013 Yohsuke Ooi <meke@momonga-linux.org>
- (0.2.0-8m)
- update service files

* Tue Sep 18 2012 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.2.0-7m)
- update %%pre section

* Mon Oct  3 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.2.0-6m)
- update post section

* Sat Aug 13 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.2.0-5m)
- support systemd

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.2.0-4m)
- rebuild for new GCC 4.6

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.2.0-3m)
- rebuild for new GCC 4.5

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.2.0-2m)
- full rebuild for mo7 release

* Wed Jul 21 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (0.2.0-1m)
- update to 0.2.0

* Tue Jan 12 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.7-5m)
- fix %%pre failure by adding "-f" option to userdel

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.1.7-4m)
- rebuild against gcc-4.4 and glibc-2.11

* Mon Jun 29 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.7-3m)
- fix BuildRequires

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.1.7-2m)
- rebuild against rpm-4.6

* Wed Dec 10 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.7-1m)
- update to 0.1.7
- add %%{_sysconfigdir}/sysconfig/rpcbind

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.1.4-6m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.1.4-5m)
- %%NoSource -> NoSource

* Tue Dec 18 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.4-4m)
- sync with fc-devel (rpcbind-0_1_4-12_fc9)
--* Mon Dec 17 2007 Steve Dickson <steved@redhat.com> 0.1.4-12
--- Changed is_loopback() and check_access() see if the calling
--  address is an address on a local interface, just not a loopback
--  address (bz 358621).
--* Wed Oct 17 2007 Steve Dickson <steved@redhat.com> 0.1.4-11
--- Reworked logic in initscript so the correct exit is 
--  used when networking does not exist or is set up
--  incorrectly.
--* Tue Oct 16 2007 Steve Dickson <steved@redhat.com> 0.1.4-10
--- Corrected a typo in the initscript from previous 
--  commit.
--* Mon Oct 15 2007 Steve Dickson <steved@redhat.com> 0.1.4-9
--- Fixed typo in Summary (bz 331811)
--- Corrected init script (bz 247046)
--* Sat Sep 15 2007 Steve Dickson <steved@redhat.com> 0.1.4-8
--- Fixed typo in init script (bz 248285)
--- Added autoconf rules to turn on secure host checking
--  via libwrap. Also turned on host check by default (bz 248284)
--- Changed init script to start service in runlevel 2 (bz 251568)
--- Added a couple missing Requires(pre) (bz 247134)

* Wed Jun 20 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.1.4-3m)
- stop auto start

* Mon May 28 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.1.4-2m)
- sync with fc-devel (rpcbind-0_1_4-7_fc8)
--* Fri May 25 2007 Steve Dickson <steved@redhat.com> 0.1.4-7
--- Fixed condrestarts (bz 241332)
--* Tue May 22 2007 Steve Dickson <steved@redhat.com> 0.1.4-6
--- Fixed an ipv6 related segfault on startup (bz 240873)

* Sat May 19 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org> 
- (0.1.4-1m)
- import from fc-devel 0.1.4-5
